/****************************************************************************
*    This file is part of CEDEC_GO.                                         *
*    Copyright (c) 2004-2011 Takenori Kubo, Youichiro Miyake, CESA          *
*                                                                           *
*    History:                                                               *
*    01/07/2011 Tweaked for CEDEC CHALLANGE 2011 by CESA                    *
*                                                                           *
*    CEDEC_GO is free software: you can redistribute it and/or modify       *
*    it under the terms of the GNU General Public License as published by   *
*    the Free Software Foundation, either version 3 of the License, or      *
*    any later version.                                                     *
*                                                                           *
*    CEDEC_GO is distributed in the hope that it will be useful,            *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of         *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
*    GNU General Public License for more details.                           *
*                                                                           *
*    You should have received a copy of the GNU General Public License      *
*    along with CEDEC_GO.  If not, see <http://www.gnu.org/licenses/>.      *
*****************************************************************************/

// GTP_IGO_02.cpp : コンソール アプリケーションのエントリ ポイントを定義します。
// GTP_IGO_02.cpp : This file defines Entry Point for Console Application.

#include "stdafx.h" // ここにあったインクルード・ライブラリは "stdafx.h"に移動しました。 // Include files are moved to "stdafx.h" // Youichiro Miyake
#include "state\IgoPosition.h"
#include "pattern\PatternIkken.h"
#include "pattern\PatternFirst.h"
#include "pattern\PatternManager.h"

class sample_engine :public engine {
  int size;
  float komi;
  struct move {
    int x;
    int y;
    COLOR color;    
    move(int _x, int _y, COLOR _color)
      :x(_x), y(_y), color(_color)
    {}
    ~move(){}
  };
  std::vector<move> moves;
  COLOR board[MAX_BOARD][MAX_BOARD];
  COLOR status[MAX_BOARD][MAX_BOARD];

 public:
  sample_engine()
    :size(19), komi(0), moves()
  {
    reset(size, komi);
  }
  virtual ~sample_engine()
  {

  }

  virtual void reset(int size, float komi) {
    this->komi = komi;
    this->size = size;
    for (int i=0; i < MAX_BOARD; i++) {
      for (int j=0; j < MAX_BOARD; j++) {
	board[i][j] = EMPTY;
	 }
    }

	pattern::PatternManager::getSingleton().clear();
	if( moves.size() != 0 )
	{
		moves.clear();
	}
  }

  virtual std::string name() {
    return ENTRY_NAME; // プログラム名をヘッダーファイルで定義してください。 Youichiro Miyake // Define your program name in Header File.
  }
  virtual std::string version() {
    return CEDEC_VERSION; // ヘッダーファイルで定義してください。 Youichiro Miyake // Define this in Header File.
  }

  //////////////////////////////////////////////////////////////////////////////////////////////////
  // 注：この関数が手を決定する思考関数です。この関数を書き換えてください。
  // デフォルトでは左上から石のない場所に順番に並べて行くプログラムになっています。Youichiro Miyake
  //
  // Attention : This function decides your next move. Modify this function.
  // In default setting, this function returns the move in order from left-top to right-down for empty place. 
  //
  //---------------------------------------------------------------//

  virtual void genmove(int& i, int& j, COLOR color){
    
#if 0	  
	for (int ii=0; ii < size; ii++) {
    for (int jj=0; jj < size; jj++) {
	if (board[ii][jj] == EMPTY) {
	  i = ii;
	  j = jj;
	  return;
	}
      }
    }
#endif
	/*
	if( color == BLACK || color == WHITE )
	{
		primitive_.push_back( pattern::PatternPrimitive( color, moves.back().x, moves.back().y ) );
		for (int ii=0; ii < size; ii++)
		{
			for (int jj=0; jj < size; jj++)
			{
				aspectBoard_.attr[i][j] = (int)board[ii][jj];
			}
		}
	}
	*/
	pattern::PatternPrimitive ret = pattern::PatternManager::getSingleton().getNext( color );
	if( ret.position.x != -1 && ret.position.y != -1 )
	{
		i = ret.position.x;
		j = ret.position.y;
		return;
	}
	// PASS
    i = -1;
    j = -1;

    return;
  }

 //---------------------------------------------------------------//

  virtual void playmove(int i, int j, COLOR color){
    moves.push_back(move(i, j, color));
    board[i][j] = color;
	if(i !=-1 && j != -1)
	{
		pattern::PatternManager::getSingleton().push( (STONE_COLOR)color,i,j);
	}
	return;
  }

  virtual void undo(){
    move m = moves.back();
    board[m.x][m.y] = EMPTY;
	pattern::PatternManager::getSingleton().pop(m.x, m.y);
    moves.pop_back();

	
  }

  virtual bool legal_move(int i, int j, COLOR color){
    return board[i][j] == EMPTY;
  }

  virtual void compute_final_status() {
    for (int i = 0; i < size; i++) {
      for (int j = 0; j < size; j++) {
	if (board[i][j] == BLACK) {
	  status[i][j] = BLACK_TERRITORY;
	} else if (board[i][j] == WHITE) {
	  status[i][j] = WHITE_TERRITORY;
	} else {
	  status[i][j] = EMPTY;
	}
      }
    }
  }
  
  virtual COLOR get_board(int i, int j) {
    return board[i][j];
  }
  virtual COLOR get_final_status(int i, int j) {
    return status[i][j];
  }

  virtual void time_settings(int main_time,
			     int byo_yomi_time,
			     int byo_yomi_stones) {
  }
  virtual void time_left(COLOR color, int time, int stones) {
  }


};

/* この部分は Windows コンソール向けに以下のように書き換えます。Youichiro Miyake
   This part is modified for Windows Console Program //

int
main(void)
{
  gtp g(new sample_engine);
  g.main_loop();
  return 0;
}
*/

int _tmain(int argc, _TCHAR* argv[])
{
	//util::DataTree<IgoPosition,IgoPosition::MatchType>IgoPositionTree;
	//std::vector< IgoPosition > pos(1);
	//pos.begin()->set( STONE_BLACK, 5, 5 );
	//pos.push_back( 
	//IgoPositionTree.setDataVector( pos );
    
//	pattern::PatternIkken ikken;
//	ikken.setup();
	

	//pattern::PatternFirst first;
	//first.setup();
	//pattern::Aspect asp;
	//asp.setup();
	//asp.attr[3][3] = 1;
	//asp.attr[6][6] = 2;
	//std::vector< pattern::PatternPrimitive > primitive;
	//primitive.push_back( pattern::PatternPrimitive( 1, 3, 3 ) );
	//primitive.push_back( pattern::PatternPrimitive( 2, 6, 6 ) );
	
	//std::vector< pattern::PatternPrimitive >  ret = ikken.matchPoint( 1, primitive, asp );
	//if( ret.begin() != ret.end() )
	//{
	//	int i = (*ret.begin()).position.x;
	//	int j = (*ret.begin()).position.y;
	//}
	/*
	asp.attr[ ret.back().position.x][ret.back().position.y] = ret.back().atter;
	primitive.push_back( ret.back() );
	ret = first.matchPoint(2,primitive,asp );
	
	if( ret.begin() != ret.end() )
	{
		int i = (*ret.begin()).position.x;
		int j = (*ret.begin()).position.y;
	}
	*/
	pattern::PatternManager::getSingleton().initialzie();
    gtp g(new sample_engine);
    g.main_loop();
	
	return 0;
}

