//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////
#pragma once
#include "PatternBase.h"
#include "PatternPrimitive.h"

#include "../IgoTypes.h"

#include "PatternFirst.h"
#include "PatternIkken.h"
#include "PatternYoseKosumi.h"
#include "PatternKeima.h"
#include "PatternOsae.h"
#include "PatternSuberi.h"
#include "PatternHane.h"
#include "PatternNige.h"

namespace pattern
{
class PatternManager
{
public:
	static PatternManager& getSingleton();
	void initialzie();
	
	PatternPrimitive getNext( int atter );
	
	void push( STONE_COLOR color, int x, int y );
	void pop( int x, int y)
	{
		aspectBoard_.attr[x][y] = 0;
		primitiveCount_--;
	}
	void clear()
	{
		for (int i=0; i < 9; i++) {
			for (int j=0; j < 9; j++) {
				aspectBoard_.attr[i][j] = 0;
			}
		}
    
		primitiveCount_ = 0;
	}
private:
	PatternManager(){}
	pattern::Aspect       aspectBoard_;
	pattern::PatternPrimitive primitive_[300];
	int primitiveCount_;
	enum
	{
		NIGE,
		OSAE,
		HANE,
		IKKEN,
		KEIMA,
		SUBERI,
		YOSE_KOSUMI,
		PATTERN_COUNT
	};

	PatternBase*      pattern_[ PATTERN_COUNT ];
	PatternFirst      first_;
	PatternIkken      ikken_;
	PatternYoseKosumi yoseKosumi_;
	PatternKeima      keima_;
	PatternOsae       osae_;
	PatternSuberi     suberi_;
	PatternHane       hane_;
	PatternNige       nige_;
};

}