//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#include "IgoPosition.h"

IVector2 IgoPosition::center;

IgoPosition::IgoPosition(void)
{
}


IgoPosition::~IgoPosition(void)
{
}

IVector2& IgoPosition::get( IVector2Util::TYPE_SIDE side, IVector2Util::TYPE_MIRROR mirror )
{
	return pos[  4 * (int)side + (int)mirror ];
}

void IgoPosition::set( STONE_COLOR color, int x, int y )
{
	stoneColor_ = color;

	for( int i = 0; i < 4; i++ )
	{
		for( int j = 0; j < 4; j++ )
		{
			int index = i*4+j;
			pos[index].set( x, y );
			pos[index] = IVector2Util::ConvertVecByDownSide( pos[index], center, (IVector2Util::TYPE_SIDE)i );
			pos[index] = IVector2Util::ConvertMirror(        pos[index], center, (IVector2Util::TYPE_MIRROR)j );
		}
	}
}

bool IgoPosition::match( IgoPosition& value, MatchType& type )
{
	if( get( type.side, type.mirror ).x != value.get( type.side, type.mirror).x ) return false;
	if( get( type.side, type.mirror ).y != value.get( type.side, type.mirror).y ) return false;

	return true;
}
