//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#pragma once

#include "..\math\IVector2.h"
#include "..\math\IVector2Util.h"
#include "..\IgoTypes.h"
#include "..\util\DataNode.h"
#include "..\util\DataTree.h"

class IgoPosition
{
public:
	//
	class MatchType
	{
	public:
		MatchType()
		{
			side   = IVector2Util::DOWN_SIDE;
			mirror = IVector2Util::NONE_MIRROR; 
		}
		void setStart()
		{
			side   = (IVector2Util::TYPE_SIDE)0;
			mirror = (IVector2Util::TYPE_MIRROR)0;
		}
		bool changeNext()
		{
			int index = side*4 + mirror;
			index++;
			if(index >= 16 )return false;
			side   = (IVector2Util::TYPE_SIDE)( index / 4 );
			mirror = (IVector2Util::TYPE_MIRROR)( index % 4 );
			return true;
		}
		IVector2Util::TYPE_SIDE   side;
		IVector2Util::TYPE_MIRROR mirror;
	};
	//
	IgoPosition(void);
	//
	~IgoPosition(void);
	//
	IgoPosition( STONE_COLOR color, int x, int y )
	{
		set( color, x, y );
	}

	IgoPosition( IgoPosition& value )
	{
		stoneColor_ = value.stoneColor_;
		for( int i = 0; i < PATTERN_COUNT; i++ )
		{
			pos[i] = value.pos[i];
		}
	}

	//
	void set( STONE_COLOR color, int x, int y );

	//
	bool match( IgoPosition& value, MatchType& type);
	//
	IVector2& get( IVector2Util::TYPE_SIDE side, IVector2Util::TYPE_MIRROR mirror );
	//
	static void setCenter( IVector2& vCenter ){ center = vCenter; }
private:
	//
	struct PosTypePattern
	{
		IVector2Util::TYPE_SIDE   side;
		IVector2Util::TYPE_MIRROR mirror;
	};

	static const int PATTERN_COUNT = 16;

	static IVector2 center;

	STONE_COLOR     stoneColor_;
	// 高速化のため回転、反転全てのパターンを持つ
	IVector2 pos[ PATTERN_COUNT ];
};


