//////////////////////////////////////////////////////////////////////
//                                                                  //
// StarCraft For CEDEC                                              //
//                                                                  //
// Copyright (c) 2004-2011 Daisuke Shikata                          //
//                                                                  //
//////////////////////////////////////////////////////////////////////

#pragma once

#include "DataNode.h"

namespace util
{

template <class T, class R>
class DataTree
{
public:
	//
	DataTree()
	{
		DataNode<T,R>* root = new DataNode<T,R>( T() );
		node_.push_back( root );
	}
	~DataTree()
	{
		std::vector< DataNode<R,T>* >::iterator iter;
		std::vector< DataNode<R,T>* >::iterator end;
		for(;;)
		{
			if( iter == end )break;
			delete (*iter);
			iter++;
		}
	}

	void setDataVector( std::vector<T>& dataVec )
	{
		DataNode<T,R>* cullent = *node_.begin();
		std::vector< DataNode<T,R>* >::iterator end  = node_.end();
		std::vector<T>::iterator data    = dataVec.begin();
		std::vector<T>::iterator dataEnd = dataVec.end();
		R hedder;
		
		for(;;)
		{	
			DataNode<T,R>* next = cullent->matchNext( *data, hedder );

			if( next == NULL )
			{
				for(;;)
				{
					if( data == dataEnd )
					{
						return;
					}
					DataNode<T,R>* tData = new DataNode<T,R>( *data );
					node_.push_back( tData );
					cullent->setNext( tData );

					cullent = node_.back();
					data++;
				}
				break;
			}
			cullent = next;
			data++;
		}	
    }
	//
	std::pair< std::vector< DataNode<T,R>* >*, R> getNextNode( std::vector<T>& dataVec )
	{
		DataNode<T,R>* cullent = *node_.begin();
		std::vector< DataNode<T,R>* >::iterator end  = node_.end();
		std::vector<T>::iterator data    = dataVec.begin();
		std::vector<T>::iterator dataEnd = dataVec.end();
		R hedder;
		hedder.setStart();
		
		for(;;)
		{
			DataNode<T,R>* next = cullent->matchNext( *data, hedder );
			if( next != NULL )
			{
				data++;
				next = next->matchNext( *data, hedder );
				if( next != NULL )
				{
					break;
				}
			}
			data = dataVec.begin();
			if( hedder.changeNext() == false )
			{
				return NULL;
			}
		}
		std::pair< std::vector< DataNode<T,R>*>*, R > ret;

		data = dataVec.begin();
		for(;;)
		{
			cullent = cullent->matchNext( *data, hedder );
			if( cullent == NULL )break;
			data++;
			if( data == dataEnd )
			{
				ret.first = cullent;
				ret.second = hedder;
			}
		}
		return ret;
		
	}

private:

	// データ
	std::vector< DataNode<T,R>* > node_;
};

}